local hiddenFrame = CreateFrame("Frame")
hiddenFrame:SetSize(1,1)
hiddenFrame:SetPoint("Right", UIParent, "Left", 100000, 0)

local container

local function ToggleButtons(_, button)
	if (button == "RightButton") then
		local kids = {container.map.addonButtons:GetChildren()}
	
		container:GetParent().sets.hideAddonButtons = (not container:GetParent().sets.hideAddonButtons) and true or nil
	
	
		for i, b in pairs(kids) do
			--if type(b) ~= "userdata" then
				b:SetFrameStrata("MEDIUM")
				if container:GetParent().sets.hideAddonButtons then
					b:Hide()
				else
					b:Show()
				end
			--end
		end
	else
		if container.buttons:IsVisible() then
			container.buttons:Hide()
		else
			container.buttons:Show()
		end
		if container.map:IsVisible() then
			container.map:Hide()
		else
			container.map:Show()
		end
	end

end

local baseW, baseH


local Masque, MasqueVersion = LibStub('Masque', true)

local buttons = {
	{"_TimeManagerClockButton" , function(parent, size)
		button = CreateFrame("Button", parent:GetName().."_ClockButton", parent)
		
		container.clock = button
		
		button.icon = button:CreateTexture(nil, "ARTWORK")
		button.icon:SetSize(size, size)
		button.icon:SetPoint("Center")

		button:SetNormalTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:SetPushedTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:GetPushedTexture():SetTexCoord(.1, .9, .1, .9)
		button:SetHighlightTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:GetHighlightTexture():SetBlendMode("ADD")

		button.TimeManagerClockTicker = button:CreateFontString(nil, "ARTWORK", "WhiteNormalNumberFont")
		button.TimeManagerClockTicker:SetPoint("TopLeft", button.icon, 5, -5)
		button.TimeManagerClockTicker:SetPoint("BottomRight", button.icon, -5, 5)

		button.TimeManagerClockTicker:SetScale(.65)

		button.TimeManagerAlarmFiredTexture = button:CreateTexture(nil, "ARTWORK")
		button.TimeManagerAlarmFiredTexture:SetAllPoints(button)

		TimeManagerClockButton_OnLoad(button)
		button:SetScript("OnEnter", TimeManagerClockButton_OnEnter)
		button:SetScript("OnLeave", TimeManagerClockButton_OnLeave)
		button:SetScript("OnUpdate", function()
		button.TimeManagerClockTicker:SetText(GameTime_GetTime(false))
		end)
		button:RegisterForClicks("AnyUp")
		button:SetScript("OnClick", function(_,btn, ...)
			if btn == "LeftButton" then
				TimeManagerClockButton_OnClick(button, btn, ...)
			else
				Stopwatch_Toggle()
			end
		end)

		return button
	end},
	{"GameTimeFrame", function(button, size)
		GameTimeFrame.icon = GameTimeFrame:CreateTexture(nil, "ARTWORK")
		GameTimeFrame.icon:SetPoint("Center")
		GameTimeFrame.icon:SetSize(size-5, size-5)
		GameTimeFrame.icon:SetTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\calendar1")
		
		GameTimeFrame.text = GameTimeFrame:GetFontString()
		GameTimeFrame.text:SetDrawLayer("OVERLAY")
		GameTimeFrame.text:SetPoint("Center", 0 , -3)
		
		GameTimeFrame:SetNormalTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		GameTimeFrame:GetNormalTexture():SetTexCoord(0,1,0,1)
		GameTimeFrame:GetNormalTexture():SetDrawLayer("OVERLAY")
		
		GameTimeFrame:SetPushedTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		GameTimeFrame:GetPushedTexture():SetTexCoord(.1,.9,.1,.9)
		GameTimeFrame:SetHighlightTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		GameTimeFrame:GetHighlightTexture():SetBlendMode("ADD")
		
	end},
	{"GarrisonLandingPageMinimapButton", function(button, size)
		GarrisonLandingPageMinimapButton:SetNormalTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		GarrisonLandingPageMinimapButton:GetNormalTexture():SetTexCoord(0,1,0,1)
		GarrisonLandingPageMinimapButton:GetNormalTexture():SetDrawLayer("OVERLAY")
		
		GarrisonLandingPageMinimapButton:SetPushedTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		GarrisonLandingPageMinimapButton:GetPushedTexture():SetTexCoord(.1,.9,.1,.9)
		
		GarrisonLandingPageMinimapButton:SetHighlightTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		GarrisonLandingPageMinimapButton:GetHighlightTexture():SetBlendMode("ADD")
		GarrisonLandingPageMinimapButton:SetSize(size, size)
	end},
	{"_MiniMapTracking", function(parent, size)
		local button = CreateFrame("Button","Goranaws_MiniMapTracking", parent)
		button:SetSize(size, size)
		button.icon = button:CreateTexture(nil, "ARTWORK")
		button.icon:SetSize(size, size)
		button.icon:SetPoint("Center")
		button.icon:SetTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\search")

		
		button:SetNormalTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:SetPushedTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:GetPushedTexture():SetTexCoord(.1, .9, .1, .9)
		button:SetHighlightTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:GetHighlightTexture():SetBlendMode("ADD")

		local showing

		button:SetScript("OnMouseDown", function()
			local drop = DropDownList1
			if drop then
				local _, frame = drop:GetPoint()
				if  frame == button then
					drop:Hide()
					drop:ClearAllPoints()
					showing = nil
					return
				end
			end
			MiniMapTrackingDropDown.point = "TOPRIGHT";
			MiniMapTrackingDropDown.relativePoint = "BOTTOMLEFT";
			ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, "Goranaws_MiniMapTracking", 8, 5);
			PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
			showing = GetTime()
		end)
		button:SetScript("OnMouseUp", MiniMapTrackingButton:GetScript("OnMouseUp"))

		button:SetScript("OnEnter", MiniMapTrackingButton:GetScript("OnEnter"))
		button:SetScript("OnLeave", MiniMapTrackingButton:GetScript("OnLeave"))
		button:SetScript("OnUpdate", function()
			local mouseIsOver
			for i = 1, UIDROPDOWNMENU_MAXLEVELS do
				local dropdown = _G["DropDownList"..i];
				if dropdown:IsShown() and dropdown:IsMouseOver() then
					mouseIsOver = true;
				end
			end
			
			if  button:IsMouseOver() then
				mouseIsOver = true;
			end
		
			local drop = DropDownList1
			if drop then
				local _, frame = drop:GetPoint()
				if  frame == button and mouseIsOver then
					showing = GetTime()
				end
			end

			if showing then
				local _, frame = GameTooltip:GetPoint()
				if  frame == button then
					GameTooltip:Hide();
				end
			
				if GetTime() - showing > 5 then
					local drop = DropDownList1
					if drop then
						drop:Hide()
						drop:ClearAllPoints()
						showing = nil
					end
				end
			end
		end)
		return button
	end},
	{"_MiniMapMailFrame", function(button, size)
	

		local button = CreateFrame("Button","Goranaws_MiniMapMail", parent)
		button:SetSize(size, size)
		button.icon = button:CreateTexture(nil, "ARTWORK")
		button.icon:SetSize(size, size)
		button.icon:SetPoint("Center")
		button.icon:SetTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\mail")

		
		button:SetNormalTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:SetPushedTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:GetPushedTexture():SetTexCoord(.1, .9, .1, .9)
		button:SetHighlightTexture("Interface\\addons\\Dominos_MINIMAP\\textures\\border")
		button:GetHighlightTexture():SetBlendMode("ADD")

		button:RegisterEvent("UPDATE_PENDING_MAIL");
		button:SetScript("OnEvent", function(self, event)
			if ( event == "UPDATE_PENDING_MAIL" ) then
				if ( HasNewMail() ) then
					button:Show();
					if( GameTooltip:IsOwned(button) ) then
						MinimapMailFrameUpdate();
					end
				else
					button:Hide();
				end
			end
		end)
		button:GetScript("OnEvent")("UPDATE_PENDING_MAIL")
		button:SetScript("OnEnter", function()
			GameTooltip:SetOwner(button, "ANCHOR_BOTTOMLEFT");
			if( GameTooltip:IsOwned(button) and  HasNewMail() ) then
				MinimapMailFrameUpdate();
			end
			button:GetScript("OnEvent")("UPDATE_PENDING_MAIL")
		end)
		button:SetScript("OnLeave", GameTooltip_Hide)
		return button
	end},
}

local BG = {bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true}


local function SetAddonButtons(scale)
	local scale = scale or .65 -- .4 --((scale*100) - 40)/100
	
	for i, button in pairs({container.map.addonButtons:GetChildren()}) do
		button:SetSize(container.buttons.buttonSize * scale, container.buttons.buttonSize * scale)
		if not container.buttons.group then
			local kids = {button:GetRegions()}
			
			for i, b in pairs(kids) do
				local w, h = unpack(b.size or {container.buttons.buttonSize, container.buttons.buttonSize})
				b:SetSize(w * scale, h * scale)

				local x, y = b.x, b.y
				b:ClearAllPoints()
				b:SetPoint("CENTER")
			end
			if not Masque then
				button.icon:ClearAllPoints()
				button.icon:SetPoint("Center", 0 , 4* scale)
			end
		end
	end
	
	if container.buttons.group then
		container.buttons.group:ReSkin(true)
	end
end

local function setDisplay(flipHori, flipVert, scale)
	local right, left, top, bottom = "Right", "Left", "Top", "Bottom"
	if flipHori then
		right, left = "Left", "Right"
	end
	if flipVert then
		top, bottom = "Bottom", "Top"
	end

	container.map:ClearAllPoints()
	container.buttons:ClearAllPoints()
	container.title:ClearAllPoints()
	
	container.map:SetPoint(bottom..left)
	container.buttons:SetPoint(bottom..right)
	container.title:SetPoint(top)
	
	SetAddonButtons(scale or .65)
	
end

local disabled = {
			"TimeManagerClockButton",
			"MiniMapWorldMapButton",
			"MinimapZoomIn",
			"MinimapZoomOut",
			"MinimapCluster",
			"MinimapBorderTop",
			"MinimapBorder",
			"MinimapBackdrop",
			"MiniMapMailFrame",
			"MiniMapTracking",
		}


local function SetClockText(scale, inset)

	local inset = inset or 5

	container.clock.TimeManagerClockTicker:SetPoint("TopLeft", button.icon, inset, -inset)
	container.clock.TimeManagerClockTicker:SetPoint("BottomRight", button.icon, -inset, inset)

	container.clock.TimeManagerClockTicker:SetScale(scale or .65)
end

function SetMapInset(inset)
	local inset = inset or 0
	container.map.icon:SetSize(baseW - inset, baseH - inset)
end

local function DragButton(button)
	local _, _, _, bX, bY = button:GetPoint()
	
	local bS = Minimap:GetSize() 
	local aS = container:GetSize() + (button:GetSize()/2.2)
	
	local s = aS / bS
	button:SetPoint("Center", container, "Center", bX * s, bY * s)
end


function GetTheMinimap(parent)
	container = CreateFrame("Frame", "Goranaws_Container", parent or UIParent)
	container:RegisterEvent("PLAYER_ENTERING_WORLD")
--	container:SetBackdrop(BACKDROP_DIALOG_32_32)

	container.parent = parent

	container.map = CreateFrame("Frame", container:GetName().."_MapFrame", container)
	container.buttons = CreateFrame("Frame", container:GetName().."_ButtonFrame", container, BackdropTemplateMixin and "BackdropTemplate")
	container.buttons:SetBackdrop(BG)
	container.title = CreateFrame("Frame", container:GetName().."_TitleFrame", container, BackdropTemplateMixin and "BackdropTemplate")
	container.title:SetBackdrop(BG)


	baseW, baseH = Minimap:GetSize()
	container.map:SetSize(baseW, baseH)
	Minimap:ClearAllPoints()
	Minimap:SetParent(container.map)
	Minimap:SetPoint("Center", container.map)
	Minimap:SetFrameStrata("LOW")
	local buttonSize =  baseH / 5
	container.buttons.buttonSize = buttonSize
	container:SetSize(baseW + buttonSize, baseH + 20)
	container:SetPoint("Center", parent or UIParent)

	container.map:SetPoint("BottomLeft")
	container.map.icon = Minimap
	
	container.map.addonButtons = CreateFrame("Frame", nil, container)
	container.map.addonButtons:SetAllPoints(container.map)
	container.buttons:SetPoint("BottomRight")
	container.buttons:SetSize(buttonSize, baseH)
	
	local group = Masque and Masque:Group("Dominos", "Minimap Buttons")
	for i, b in pairs(buttons) do
		local name, info = unpack(b)
		local button = _G[name]
		if button then
			info(button, buttonSize)
		else
			button = info(container.buttons, buttonSize)
		end
		button:SetHitRectInsets(0, 0, 0, 0);
		button:ClearAllPoints()
		button:SetParent(container.buttons)
		button:SetPoint("Bottom", container.buttons, "Top", 0, -(buttonSize * i))
		button:SetSize(buttonSize, buttonSize)
		
		

		local _ = group and group:AddButton(button, "Minimap")
		
	end
	container:SetScript("OnEvent", function(_, event, ...)

		for i, button in pairs({Minimap:GetChildren()}) do
			if type(button) ~= "userdata" then
				button:SetParent(container.map.addonButtons)
				button:SetFrameStrata("MEDIUM")
				if container:GetParent().sets then
					if container:GetParent().sets.hideAddonButtons then
						button:Hide()
					else
						button:Show()
					end
				end
				
				
				--DragButton(button)
				
				local kids = {button:GetRegions()}
					for i, b in pairs(kids) do
						_,_,_, b.x, b.y = b:GetPoint()
						
						if b.GetTexture then
							local texture = b:GetTexture()	
							if texture == "Interface\\Minimap\\UI-Minimap-Background" then
								button.Backdrop = b
								button.FloatingBG = b
								if not Masque then
									b:SetTexCoord(0,1,.22,1)
									b:SetSize(buttonSize, buttonSize+4)
								end
							elseif texture == "Interface\\Minimap\\MiniMap-TrackingBorder" then
								--button.QuestBorder = b
								if group then
									b:Hide()
								end
								button.border = b
								if not Masque then
									b:SetTexCoord(0,.6,0,.75)
									b:SetSize(b:GetWidth()-12, b:GetHeight()-4)
								end
							elseif texture == "Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight" then
								button.highlight = b
								if not Masque then
									b:SetTexCoord(.1,1,.23,1.05)
									b:SetSize(buttonSize+2, buttonSize-2)
								end
							else
								if group and b ~= button.icon then
									b:Hide()
									b:SetTexture("")
								end
							end
						end
						
						b.size = {b:GetSize()}
					end
					
					local _ = group and group:AddButton(button, "Minimap")
				
				-- button:HookScript("OnDragStart", function()
					-- button:HookScript("OnUpdate", function()
						-- DragButton(button)
					-- end)
				-- end)
	
			end
		end

		SetAddonButtons(parent.sets.buttonScale or .65, true)
	end)
	local normal = container.map:CreateTexture(nil, "OVERLAY")
	normal:SetSize(baseW, baseH)
	normal:SetPoint("Center")
	
	local pushed = container.map:CreateTexture(nil, "OVERLAY")
	pushed:SetSize(baseW, baseH)
	pushed:SetPoint("Center")
	
	local highlight = container.map:CreateTexture(nil, "OVERLAY")
	highlight:SetSize(baseW, baseH)
	highlight:SetPoint("Center")
	
	
	function container.map:GetNormalTexture()
		return normal:GetTexture()
	end		
	function container.map:GetPushedTexture()
		return pushed:GetTexture()
	end		
	function container.map:GetHighlightTexture()
		return highlight:GetTexture()
	end	
			
	function container.map:SetNormalTexture(texture)
		return normal:SetTexture(texture)
	end		
	function container.map:SetPushedTexture(texture)
		return pushed:SetTexture(texture)
	end		
	function container.map:SetHighlightTexture(texture)
		return highlight:SetTexture(texture)
	end
	
	local group = Masque and Masque:Group("Dominos", "Minimap")


	local _ = group and group:AddButton(container.map, "Minimap")
	
	container.title:SetPoint("Top")
	container.title:SetSize(baseW + buttonSize, 20)

	MinimapZoneTextButton:ClearAllPoints()
	MinimapZoneTextButton:SetParent(container.title)
	MinimapZoneTextButton:SetAllPoints(container.title)
	
	
	MinimapZoneTextButton:RegisterForClicks("AnyUp")
	MinimapZoneTextButton:SetScript("OnClick", ToggleButtons)
	
	MinimapZoneText:SetAllPoints(container.title)

	Minimap:SetMaskTexture("Interface\\AddOns\\Dominos_MINIMAP\\textures\\".."square")

	function GetMinimapShape() return string.upper("square") end

	Minimap:SetScript("OnMouseWheel", function(self, arg1)
		if (self:GetZoom()+arg1) < 0 then
			arg1 = 0
		end
		self:SetZoom(self:GetZoom()+arg1)
	end)

	for i, disable in pairs(disabled) do
		local dis = _G[disable]
		if dis then
			dis:Hide()
			if dis.SetTexture then
				dis:SetTexture("")
				function dis:SetTexture()
				
				end
			else
				dis:SetParent(hiddenFrame)
				dis:SetScript("OnShow", function() dis:Hide() end)					
			end
		end
	end

	--setDisplay(true, true)
	return container
end
local MinimapFrame = _G.Minimap
if not MinimapFrame then
    return
end

local Addon = _G["Dominos"]

local MinimapBar = Addon:CreateClass('Frame', Addon.Frame)

function MinimapBar:New()
    local bar = MinimapBar.proto.New(self, 'map')

	bar.map = GetTheMinimap(bar)

	bar:Layout()

    return bar
end

function MinimapBar:GetDefaults()
    return {
        point = 'CENTER',
        x = 0,
        y = 0,
        showInPetBattleUI = true,
        showInOverrideUI = true
    }
end

function MinimapBar:Layout()
	local w, h = self.map:GetSize()
	local pW, pH = self:GetPadding()
	
	setDisplay(self.sets.flipHori, self.sets.flipVert, self.sets.buttonScale or 1)
    self:SetSize(w + pW, h + pH)
	
	self.sets.clockScale = self.sets.clockScale or 100
	
	SetClockText(self.sets.clockScale/100, self.sets.clockInset)
	SetMapInset(self.sets.mapInset)
	
end


function MinimapBar:Rescale()
    self:SetScale(.6 + self:GetFrameScale())
end

function MinimapBar:OnCreateMenu(menu)
    self:AddLayoutPanel(menu)
    menu:AddFadingPanel()
end

function MinimapBar:AddLayoutPanel(menu)
    local l = LibStub('AceLocale-3.0'):GetLocale('Dominos-Config')
    local panel = menu:NewPanel(l.Layout)

	panel:NewCheckButton{
		name = "Flip Left to Right",
		tooltip = "Display Buttons on Left",
		get = function() return panel.owner.sets.flipHori end,
		set = function(_, enable) panel.owner.sets.flipHori = enable panel.owner:Layout() end
	}

	panel:NewCheckButton{
		name = "Flip Top to Bottom",
		tooltip = "Display title on bottom",
		get = function() return panel.owner.sets.flipVert end,
		set = function(_, enable) panel.owner.sets.flipVert = enable panel.owner:Layout() end
	}

    panel.scaleSlider = panel:NewScaleSlider()
    panel.paddingSlider = panel:NewPaddingSlider()
	
	
	    panel:NewSlider {
            name = "Clock Font Size",
            min = 45,
            max = function()
                return 110
            end,
            get = function()
                return self.sets.clockScale or 65
            end,
            set = function(_, value)
                self.sets.clockScale = value
                panel.owner:Layout()
            end
        }	
	
	    panel:NewSlider {
            name = "Clock Font Inset",
            min = 0,
            max = function()
                return 10
            end,
            get = function()
                return self.sets.clockInset or 5
            end,
            set = function(_, value)
                self.sets.clockInset = value
                panel.owner:Layout()
            end
        }
		
	    local slider = panel:NewSlider {
            name = "Map Inset",
            min = 0,
            max = function()
                return 50
            end,
            get = function()
                return self.sets.mapInset or 0
            end,
            set = function(_, value)
                self.sets.mapInset = value
                panel.owner:Layout()
            end
        }
		
		
		
	    local slider = panel:NewSlider {
            name = "Addon Button Scale",
            min = 25,
            max = function()
                return 150
            end,
            get = function()
                return (self.sets.buttonScale *100 or 100)
            end,
            set = function(_, value)
                self.sets.buttonScale = value/100
                panel.owner:Layout()
            end
        }

		
end


local MinimapModule = Addon:NewModule('MinimapBar', 'AceEvent-3.0')

function MinimapModule:Load()
    if not self.initialized then
        self.initialized = true

        -- setup the container watcher
        Minimap.ignoreFramePositionManager = true

    end

    self.frame = MinimapBar:New()
    self:RegisterEvent('PLAYER_REGEN_ENABLED')
end

function MinimapModule:Unload()
    self.frame:Free()
    self:UnregisterEvent('PLAYER_REGEN_ENABLED')
end

function MinimapModule:PLAYER_REGEN_ENABLED()
    if self.dirty then
        self.dirty = nil

        if self.frame then
            self.frame:Layout()
        end
    end
end
